# default.tcl
# LEG20070912
#
# Some sample cmd parsers
#
# This file is part of TTP the Tcl Template Parser
# TTP is (c) 2007 Georg Lehner <jorge@magma.com.ni>
# Share and use it as you like, but don't blame me
#

#
namespace eval cmd {
    proc dump {args} {out $args}

    variable mapValue
    proc map args {
	variable mapValue
	foreach {key value} $args {break}
	set mapValue($key) $value }

    variable shEnv
    # TODO, does not work correctly yet
    proc sh args {
	variable shEnv
	set d [lindex $args 0]
	set i [string first "=" $d]
	set varName [string trim [string range $d 0 [incr i -1]]]
	incr i 2
	set j [string first "\#" $d $i]
	if {$j == -1} {set j end}
	set value [subst -nocommands [string trim [string range $d $i $j]]]
	set shEnv($varName) $value }
}

# Test the parsers:
# by invoking with ttp -D type <parse type>
# and setting up a <parse type>.cfg file

# if we do not parse the commandline ttp does it later
::opt::argv

# if we are called with non option arguments
# we rather want to parse them as files
if [llength $::opt::argv] return

::opt::usage

log INFO \
"

This is TTP's default.tcl, which only serves as an example.
Change it at [file join $root default.tcl] to suit your needs.

You can play with the 'sh' and the 'map' parser by calling:

$argv0 -D type sh
$argv0 -D type map

and by editing: [file join $root sh.cfg] and [file join $root map.cfg]
"

if [info exists type] {
    log INFO "parsing [file join $root $type.cfg]"
    parse $type.cfg cmd ::cmd::$type
    switch $type {
	map {parray ::cmd::mapValue}
	sh {parray ::cmd::shEnv}
	default {
	    # we never come here, since $type.cfg
	    # would throw an error an us at 'parse'
	    fatal "no cfg parser for $type."}}

    exit
}
